Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/HeuristicLab.Problems.GeneralizedQuadraticAssignment-3.3.csproj
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/HeuristicLab.Problems.GeneralizedQuadraticAssignment-3.3.csproj	(revision 7411)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/HeuristicLab.Problems.GeneralizedQuadraticAssignment-3.3.csproj	(revision 7412)
@@ -94,4 +94,6 @@
     <Compile Include="Evaluators\GQAPEvaluator.cs" />
     <Compile Include="GeneralizedQuadraticAssignmentProblem.cs" />
+    <Compile Include="GQAPIntegerVectorProximityCalculator.cs" />
+    <Compile Include="Interfaces\IGQAPMerger.cs" />
     <Compile Include="Interfaces\IGQAPNMoveEvaluator.cs" />
     <Compile Include="Interfaces\IEquipmentAwareGQAPOperator.cs" />
@@ -120,4 +122,5 @@
     <Compile Include="Operators\GQAPSolutionCreator.cs" />
     <Compile Include="Operators\GreedyRandomizedSolutionCreator.cs" />
+    <Compile Include="Operators\QualitySimilarityMerger.cs" />
     <Compile Include="Operators\RandomSolutionCreator.cs" />
     <Compile Include="Operators\RelocateEquipmentManipluator.cs" />
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IGQAPEvaluationOperator.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IGQAPEvaluationOperator.cs	(revision 7411)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IGQAPEvaluationOperator.cs	(revision 7412)
@@ -29,8 +29,10 @@
     ILookupParameter<DoubleMatrix> DistancesParameter { get; }
     ILookupParameter<DoubleMatrix> InstallationCostsParameter { get; }
-    ILookupParameter<DoubleValue> TransportationCostsParameter { get; }
     ILookupParameter<DoubleArray> DemandsParameter { get; }
     ILookupParameter<DoubleArray> CapacitiesParameter { get; }
     ILookupParameter<IntegerVector> AssignmentParameter { get; }
+
+    IValueLookupParameter<DoubleValue> TransportationCostsParameter { get; }
+    IValueLookupParameter<DoubleValue> OverbookedCapacityPenaltyParameter { get; }
   }
 }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IGQAPEvaluator.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IGQAPEvaluator.cs	(revision 7411)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IGQAPEvaluator.cs	(revision 7412)
@@ -26,5 +26,7 @@
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
   public interface IGQAPEvaluator : IGQAPEvaluationOperator, ISingleObjectiveEvaluator {
-    ILookupParameter<DoubleValue> InfeasibilityParameter { get; }
+    ILookupParameter<DoubleValue> FlowDistanceQualityParameter { get; }
+    ILookupParameter<DoubleValue> InstallationQualityParameter { get; }
+    ILookupParameter<DoubleValue> OverbookedCapacityParameter { get; }
   }
 }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IGQAPLocalImprovementOperator.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IGQAPLocalImprovementOperator.cs	(revision 7411)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IGQAPLocalImprovementOperator.cs	(revision 7412)
@@ -28,6 +28,7 @@
   public interface IGQAPLocalImprovementOperator : IGQAPOperator, ILocalImprovementOperator {
     ILookupParameter<DoubleValue> QualityParameter { get; }
-    ILookupParameter<DoubleValue> InfeasibilityParameter { get; }
-    ILookupParameter<ResultCollection> ResultsParameter { get; }
+    ILookupParameter<DoubleValue> FlowDistanceQualityParameter { get; }
+    ILookupParameter<DoubleValue> InstallationQualityParameter { get; }
+    ILookupParameter<DoubleValue> OverbookedCapacityParameter { get; }
     IValueLookupParameter<IntValue> MaximumCandidateListSizeParameter { get; }
     IValueLookupParameter<IntValue> MaximumSampleSizeParameter { get; }
@@ -36,7 +37,8 @@
     ILookupParameter<DoubleMatrix> DistancesParameter { get; }
     ILookupParameter<DoubleMatrix> InstallationCostsParameter { get; }
-    ILookupParameter<DoubleValue> TransportationCostsParameter { get; }
     ILookupParameter<DoubleArray> DemandsParameter { get; }
     ILookupParameter<DoubleArray> CapacitiesParameter { get; }
+    IValueLookupParameter<DoubleValue> TransportationCostsParameter { get; }
+    IValueLookupParameter<DoubleValue> OverbookedCapacityPenaltyParameter { get; }
   }
 }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IGQAPMerger.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IGQAPMerger.cs	(revision 7412)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IGQAPMerger.cs	(revision 7412)
@@ -0,0 +1,33 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+using HeuristicLab.Problems.GeneralizedQuadraticAssignment.Common;
+
+namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
+  public interface IGQAPMerger : IMerger, IGQAPOperator {
+    ILookupParameter<IntegerVector> AssignmentParameter { get; }
+    ILookupParameter<DoubleValue> QualityParameter { get; }
+    IValueLookupParameter<BoolValue> MaximizationParameter { get; }
+  }
+}
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IGQAPMoveEvaluator.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IGQAPMoveEvaluator.cs	(revision 7411)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IGQAPMoveEvaluator.cs	(revision 7412)
@@ -20,7 +20,13 @@
 #endregion
 
+using HeuristicLab.Core;
+using HeuristicLab.Data;
 using HeuristicLab.Optimization;
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
-  public interface IGQAPMoveEvaluator : IGQAPEvaluationOperator, ISingleObjectiveMoveEvaluator { }
+  public interface IGQAPMoveEvaluator : IGQAPEvaluationOperator, ISingleObjectiveMoveEvaluator {
+    ILookupParameter<DoubleValue> FlowDistanceQualityParameter { get; }
+    ILookupParameter<DoubleValue> InstallationQualityParameter { get; }
+    ILookupParameter<DoubleValue> OverbookedCapacityParameter { get; }
+  }
 }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/NMoveMaker.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/NMoveMaker.cs	(revision 7411)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/NMoveMaker.cs	(revision 7412)
@@ -42,12 +42,24 @@
       get { return (ILookupParameter<DoubleValue>)Parameters["Quality"]; }
     }
-    public ILookupParameter<DoubleValue> InfeasibilityParameter {
-      get { return (ILookupParameter<DoubleValue>)Parameters["Infeasibility"]; }
+    public ILookupParameter<DoubleValue> FlowDistanceQualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["FlowDistanceQuality"]; }
+    }
+    public ILookupParameter<DoubleValue> InstallationQualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["InstallationQuality"]; }
+    }
+    public ILookupParameter<DoubleValue> OverbookedCapacityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["OverbookedCapacity"]; }
     }
     public ILookupParameter<DoubleValue> MoveQualityParameter {
       get { return (ILookupParameter<DoubleValue>)Parameters["MoveQuality"]; }
     }
-    public ILookupParameter<DoubleValue> MoveInfeasibilityParameter {
-      get { return (ILookupParameter<DoubleValue>)Parameters["MoveInfeasibility"]; }
+    public ILookupParameter<DoubleValue> MoveFlowDistanceQualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["MoveFlowDistanceQuality"]; }
+    }
+    public ILookupParameter<DoubleValue> MoveInstallationQualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["MoveInstallationQuality"]; }
+    }
+    public ILookupParameter<DoubleValue> MoveOverbookedCapacityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["MoveOverbookedCapacity"]; }
     }
 
@@ -60,7 +72,11 @@
       Parameters.Add(new LookupParameter<NMove>("Move", "The move to perform."));
       Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The solution quality."));
-      Parameters.Add(new LookupParameter<DoubleValue>("Infeasibility", "The infeasibility of a solution."));
+      Parameters.Add(new LookupParameter<DoubleValue>("FlowDistanceQuality", "The quality regarding the flow-distance criteria."));
+      Parameters.Add(new LookupParameter<DoubleValue>("InstallationQuality", "The quality regarding the installation costs."));
+      Parameters.Add(new LookupParameter<DoubleValue>("OverbookedCapacity", "The sum of the overbooked capacities relative to the capacity of each location."));
       Parameters.Add(new LookupParameter<DoubleValue>("MoveQuality", "The quality of the move if it would be applied."));
-      Parameters.Add(new LookupParameter<DoubleValue>("MoveInfeasibility", "The infeasibility of the move if it would be applied."));
+      Parameters.Add(new LookupParameter<DoubleValue>("MoveFlowDistanceQuality", "The quality of the move regarding the flow-distance criteria."));
+      Parameters.Add(new LookupParameter<DoubleValue>("MoveInstallationQuality", "The quality of the move regarding the installation costs."));
+      Parameters.Add(new LookupParameter<DoubleValue>("MoveOverbookedCapacity", "The sum of the overbooked capacities of the move relative to the capacity of each location."));
     }
 
@@ -78,5 +94,7 @@
       Apply(AssignmentParameter.ActualValue, MoveParameter.ActualValue);
       QualityParameter.ActualValue.Value = MoveQualityParameter.ActualValue.Value;
-      InfeasibilityParameter.ActualValue.Value = MoveInfeasibilityParameter.ActualValue.Value;
+      FlowDistanceQualityParameter.ActualValue.Value = MoveFlowDistanceQualityParameter.ActualValue.Value;
+      InstallationQualityParameter.ActualValue.Value = MoveInstallationQualityParameter.ActualValue.Value;
+      OverbookedCapacityParameter.ActualValue.Value = MoveOverbookedCapacityParameter.ActualValue.Value;
       return base.Apply();
     }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/StochasticNMoveMultiMoveGenerator.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/StochasticNMoveMultiMoveGenerator.cs	(revision 7411)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/StochasticNMoveMultiMoveGenerator.cs	(revision 7412)
@@ -60,5 +60,5 @@
     public static IEnumerable<NMove> Generate(IRandom random, IntegerVector assignment, int n, DoubleArray capacities, int sampleSize) {
       for (int i = 0; i < sampleSize; i++)
-        yield return StochasticNMoveSingleMoveGenerator.Generate(random, assignment, n, capacities);
+        yield return StochasticNMoveSingleMoveGenerator.GenerateUpToN(random, assignment, n, capacities);
     }
 
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/StochasticNMoveSingleMoveGenerator.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/StochasticNMoveSingleMoveGenerator.cs	(revision 7411)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/StochasticNMoveSingleMoveGenerator.cs	(revision 7412)
@@ -54,9 +54,12 @@
     }
 
-    public static NMove Generate(IRandom random, IntegerVector assignment, int n, DoubleArray capacities) {
-      int moving = random.Next(n) + 1;
-      int[] equipments = new int[moving], locations = new int[moving];
+    public static NMove GenerateUpToN(IRandom random, IntegerVector assignment, int n, DoubleArray capacities) {
+      return GenerateExactlyN(random, assignment, random.Next(n) + 1, capacities);
+    }
+
+    public static NMove GenerateExactlyN(IRandom random, IntegerVector assignment, int n, DoubleArray capacities) {
+      int[] equipments = new int[n], locations = new int[n];
       HashSet<int> chosenEquipments = new HashSet<int>();
-      for (int i = 0; i < moving; i++) {
+      for (int i = 0; i < n; i++) {
         do {
           equipments[i] = random.Next(assignment.Length);
@@ -71,5 +74,5 @@
 
     public override IEnumerable<NMove> GenerateMoves(IntegerVector assignment, int n) {
-      yield return Generate(RandomParameter.ActualValue, assignment, n, CapacitiesParameter.ActualValue);
+      yield return GenerateUpToN(RandomParameter.ActualValue, assignment, n, CapacitiesParameter.ActualValue);
     }
   }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/ApproximateLocalSearch.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/ApproximateLocalSearch.cs	(revision 7411)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/ApproximateLocalSearch.cs	(revision 7412)
@@ -55,6 +55,12 @@
       get { return (ILookupParameter<DoubleValue>)Parameters["Quality"]; }
     }
-    public ILookupParameter<DoubleValue> InfeasibilityParameter {
-      get { return (ILookupParameter<DoubleValue>)Parameters["Infeasibility"]; }
+    public ILookupParameter<DoubleValue> FlowDistanceQualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["FlowDistanceQuality"]; }
+    }
+    public ILookupParameter<DoubleValue> InstallationQualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["InstallationQuality"]; }
+    }
+    public ILookupParameter<DoubleValue> OverbookedCapacityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["OverbookedCapacity"]; }
     }
     public ILookupParameter<ResultCollection> ResultsParameter {
@@ -79,7 +85,4 @@
       get { return (ILookupParameter<DoubleMatrix>)Parameters["InstallationCosts"]; }
     }
-    public ILookupParameter<DoubleValue> TransportationCostsParameter {
-      get { return (ILookupParameter<DoubleValue>)Parameters["TransportationCosts"]; }
-    }
     public ILookupParameter<DoubleArray> DemandsParameter {
       get { return (ILookupParameter<DoubleArray>)Parameters["Demands"]; }
@@ -88,5 +91,13 @@
       get { return (ILookupParameter<DoubleArray>)Parameters["Capacities"]; }
     }
-
+    public IValueLookupParameter<DoubleValue> TransportationCostsParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["TransportationCosts"]; }
+    }
+    public IValueLookupParameter<DoubleValue> OverbookedCapacityPenaltyParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["OverbookedCapacityPenalty"]; }
+    }
+    public IValueLookupParameter<PercentValue> OneMoveProbabilityParameter {
+      get { return (IValueLookupParameter<PercentValue>)Parameters["OneMoveProbability"]; }
+    }
 
     [StorableConstructor]
@@ -99,5 +110,7 @@
       Parameters.Add(new LookupParameter<IntValue>("EvaluatedSolutions", "The number of evaluated solution equivalents."));
       Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The solution quality."));
-      Parameters.Add(new LookupParameter<DoubleValue>("Infeasibility", "The infeasibility describes the sum of the overbooked capacities."));
+      Parameters.Add(new LookupParameter<DoubleValue>("FlowDistanceQuality", "The quality regarding the flow-distance criteria."));
+      Parameters.Add(new LookupParameter<DoubleValue>("InstallationQuality", "The quality regarding the installation costs."));
+      Parameters.Add(new LookupParameter<DoubleValue>("OverbookedCapacity", "The sum of the overbooked capacities relative to the capacity of each location."));
       Parameters.Add(new LookupParameter<ResultCollection>("Results", "The result collection that stores the results."));
       Parameters.Add(new ValueLookupParameter<IntValue>("MaximumCandidateListSize", "The maximum number of candidates that should be found in each step.", new IntValue(10)));
@@ -107,7 +120,9 @@
       Parameters.Add(new LookupParameter<DoubleMatrix>("Distances", "The distances matrix describes the distances between the locations at which the equipment can be installed."));
       Parameters.Add(new LookupParameter<DoubleMatrix>("InstallationCosts", "The installation costs matrix describes the installation costs of installing equipment i at location j."));
-      Parameters.Add(new LookupParameter<DoubleValue>("TransportationCosts", "The transportation cost represents the flow-unit per distance-unit cost factor. This value can also be set to 1 if these costs are factored into the weights matrix already."));
       Parameters.Add(new LookupParameter<DoubleArray>("Demands", "The demands vector describes the space requirements of the equipments."));
       Parameters.Add(new LookupParameter<DoubleArray>("Capacities", "The capacities vector describes the available space at the locations."));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("TransportationCosts", "The transportation cost represents the flow-unit per distance-unit cost factor. This value can also be set to 1 if these costs are factored into the weights matrix already."));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("OverbookedCapacityPenalty", "The multiplier for the constraint violation when added to the quality."));
+      Parameters.Add(new ValueLookupParameter<PercentValue>("OneMoveProbability", "The probability for performing a 1-move, which is the opposite of performing a 2-move.", new PercentValue(.5)));
     }
 
@@ -124,42 +139,54 @@
     /// <param name="assignment">The equipment-location assignment vector.</param>
     /// <param name="quality">The solution quality.</param>
-    /// <param name="infeasibility">The infeasibility describes the sum of the overbooked capacities.</param>
+    /// <param name="flowDistanceQuality">The quality regarding the flow-distance criteria.</param>
+    /// <param name="installationQuality">The quality regarding the installation costs.</param>
+    /// <param name="overbookedCapacity">The sum of the overbooked capacities relative to the capacity of each location.</param>
     /// <param name="maxCLS">The maximum number of candidates that should be found in each step.</param>
     /// <param name="maxSampleSize">The maximum number of candidates that should be sampled in each step.</param>
     /// <param name="maximumIterations">The maximum number of iterations that should be performed.</param>
-    /// <param name="demands">The demands vector describes the space requirements of the equipments.</param>
-    /// <param name="capacities">The capacities vector describes the available space at the locations.</param>
     /// <param name="weights">The weights matrix describes the flows between the equipments.</param>
     /// <param name="distances">The distances matrix describes the distances between the locations at which the equipment can be installed.</param>
     /// <param name="installationCosts">The installation costs matrix describes the installation costs of installing equipment i at location j</param>
+    /// <param name="demands">The demands vector describes the space requirements of the equipments.</param>
+    /// <param name="capacities">The capacities vector describes the available space at the locations.</param>
     /// <param name="transportationCosts">The transportation cost represents the flow-unit per distance-unit cost factor. This value can also be set to 1 if these costs are factored into the weights matrix already.</param>
-    public static void Apply(IRandom random, IntegerVector assignment, DoubleValue quality, DoubleValue infeasibility,
-                             IntValue maxCLS, IntValue maxSampleSize, IntValue maximumIterations,
-                             DoubleArray demands, DoubleArray capacities,
-                             DoubleMatrix weights, DoubleMatrix distances,
-                             DoubleMatrix installationCosts,
-                             DoubleValue transportationCosts) {
+    /// <param name="overbookedCapacityPenalty"></param>
+    /// <param name="oneMoveProbability">The probability for performing a 1-move, which is the opposite of performing a 2-move.</param>
+    public static void Apply(IRandom random, IntegerVector assignment,
+      DoubleValue quality, DoubleValue flowDistanceQuality, DoubleValue installationQuality, DoubleValue overbookedCapacity,
+      IntValue maxCLS, IntValue maxSampleSize, IntValue maximumIterations,
+      DoubleMatrix weights, DoubleMatrix distances, DoubleMatrix installationCosts, DoubleArray demands, DoubleArray capacities,
+      DoubleValue transportationCosts, DoubleValue overbookedCapacityPenalty, PercentValue oneMoveProbability) {
+
       for (int i = 0; i < maximumIterations.Value; i++) {
         int count = 0;
-        var CLS = new List<Tuple<NMove, DoubleValue, DoubleValue>>();
+        var CLS = new List<Tuple<NMove, double, double, double, double>>();
         double sum = 0.0;
         do {
-          var move = StochasticNMoveSingleMoveGenerator.Generate(random, assignment, 2, capacities);
-          DoubleValue moveInfeasibility;
-          var moveQuality = GQAPNMoveEvaluator.Evaluate(move, assignment, quality,
-            demands, capacities, weights, distances,
-            installationCosts, transportationCosts, out moveInfeasibility);
-          if (moveInfeasibility.Value <= 0.0 && moveQuality.Value < quality.Value) {
-            CLS.Add(Tuple.Create(move, moveQuality, moveInfeasibility));
-            sum += 1.0 / moveQuality.Value;
+          NMove move;
+          if (random.NextDouble() < oneMoveProbability.Value)
+            move = StochasticNMoveSingleMoveGenerator.GenerateExactlyN(random, assignment, 1, capacities);
+          else move = StochasticNMoveSingleMoveGenerator.GenerateExactlyN(random, assignment, 2, capacities);
+
+          double moveFlowDistanceQuality, moveInstallationQuality, moveOverbookedCapacity;
+          GQAPNMoveEvaluator.Evaluate(move, assignment, weights, distances, installationCosts,
+            demands, capacities, out moveFlowDistanceQuality, out moveInstallationQuality, out moveOverbookedCapacity);
+          double moveQuality = GQAPEvaluator.GetCombinedQuality(moveFlowDistanceQuality, moveInstallationQuality, moveOverbookedCapacity,
+            transportationCosts.Value, overbookedCapacityPenalty.Value);
+
+          if (moveOverbookedCapacity <= 0.0 && moveQuality < 0.0) {
+            CLS.Add(Tuple.Create(move, moveQuality, moveFlowDistanceQuality, moveInstallationQuality, moveOverbookedCapacity));
+            sum += 1.0 / moveQuality;
           }
           count++;
         } while (CLS.Count < maxCLS.Value && count < maxSampleSize.Value);
-        if (CLS.Count == 0) return; // END
+
+        if (CLS.Count == 0)
+          return; // END
         else {
           var ball = random.NextDouble() * sum;
           var selected = CLS.Last();
           foreach (var candidate in CLS) {
-            ball -= 1.0 / candidate.Item2.Value;
+            ball -= 1.0 / candidate.Item2;
             if (ball <= 0.0) {
               selected = candidate;
@@ -168,6 +195,8 @@
           }
           NMoveMaker.Apply(assignment, selected.Item1);
-          quality.Value = selected.Item2.Value;
-          infeasibility.Value = selected.Item3.Value;
+          quality.Value += selected.Item2;
+          flowDistanceQuality.Value += selected.Item3;
+          installationQuality.Value += selected.Item4;
+          overbookedCapacity.Value += selected.Item5;
         }
       }
@@ -178,12 +207,16 @@
         AssignmentParameter.ActualValue,
         QualityParameter.ActualValue,
-        InfeasibilityParameter.ActualValue,
+        FlowDistanceQualityParameter.ActualValue,
+        InstallationQualityParameter.ActualValue,
+        OverbookedCapacityParameter.ActualValue,
         MaximumCandidateListSizeParameter.ActualValue,
         MaximumSampleSizeParameter.ActualValue,
         MaximumIterationsParameter.ActualValue,
-        DemandsParameter.ActualValue, CapacitiesParameter.ActualValue,
         WeightsParameter.ActualValue, DistancesParameter.ActualValue,
         InstallationCostsParameter.ActualValue,
-        TransportationCostsParameter.ActualValue);
+        DemandsParameter.ActualValue, CapacitiesParameter.ActualValue,
+        TransportationCostsParameter.ActualValue,
+        OverbookedCapacityPenaltyParameter.ActualValue,
+        OneMoveProbabilityParameter.ActualValue);
       return base.Apply();
     }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/GreedyRandomizedSolutionCreator.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/GreedyRandomizedSolutionCreator.cs	(revision 7411)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/GreedyRandomizedSolutionCreator.cs	(revision 7412)
@@ -60,5 +60,5 @@
       while (tries < maxTries) {
         assignment.Clear();
-        demands.Select((v, i) => slack[i] = v).Enumerate();
+        capacities.Select((v, i) => slack[i] = v).Enumerate();
         HashSet<int> CF = new HashSet<int>(), // set of chosen facilities / equipments
           T = new HashSet<int>(), // set of facilities / equpiments that can be assigned to the set of chosen locations (CL)
